#ifndef __MIPS_H__
#define __MIPS_H__

#define KSEG0_BASE	0x80000000
#define KSEG1_BASE	0xA0000000

#define CP0_INDEX	$0
#define CP0_ENTRYLO0	$2
#define CP0_ENTRYLO1	$3
#define CP0_CONTEXT	$4
#define CP0_PAGEMASK	$5
#define CP0_WIRED	$6
#define CP0_ENTRYHI	$10
#define CP0_STATUS	$12
#define CP0_INTCTL	$12, 1
#define CP0_CAUSE	$13
#define CP0_EPC		$14
#define CP0_EBASE	$15, 1
#define CP0_CONFIG	$16
#define CP0_WATCHLO	$18
#define CP0_TAGLO	$28
#define CP0_TAGHI	$29

#define STATUS_CP0	0x10000000
#define STATUS_BEV	0x00400000
#define STATUS_IRQ	0x0000fc00
#define STATUS_UM	0x00000010
#define STATUS_ERL	0x00000004
#define STATUS_EXL	0x00000002
#define STATUS_IE	0x00000001

#define CAUSE_IV	0x00800000

#define EBASE_MASK	0x3ffff000

#define INTCTL_MASK	0x000003e0

#define TLB_CACHED	0x00000018
#define TLB_UNCACHED	0x00000010
#define TLB_DIRTY	0x00000004
#define TLB_VALID	0x00000002
#define TLB_GLOBAL	0x00000001

#define TLB_READ	(TLB_CACHED | TLB_VALID)
#define TLB_WRITE	(TLB_CACHED | TLB_DIRTY | TLB_VALID)
#define TLB_ALL_READ	(TLB_CACHED | TLB_VALID | TLB_GLOBAL)
#define TLB_ALL_WRITE	(TLB_CACHED | TLB_DIRTY | TLB_VALID | TLB_GLOBAL)

#define CONFIG_CM_UNCACHED		2
#define CONFIG_CM_CACHABLE_NONCOHERENT	3

#endif /* __MIPS_H__ */
